enum {
    PROP_0,
    PROP_DISABLE_CSD,
    PROP_DARK_THEME
};

static void boilerplate_window_set_property (GObject      *object,
                                             guint         prop_id,
                                             const GValue *value,
                                             GParamSpec   *pspec);
                         
static void boilerplate_window_get_property (GObject    *object,
                                             guint       prop_id,
                                             GValue     *value,
                                             GParamSpec *pspec);

static void
boilerplate_window_class_init (GstMyFilterClass *klass)
{
    //GObjectClass *object_class = G_OBJECT_CLASS (klass);

    G_OBJECT_CLASS (klass)->set_property = boilerplate_window_set_property;
    G_OBJECT_CLASS (klass)->get_property = boilerplate_window_get_property;

    /* define properties */
    g_object_class_install_property (
        object_class, PROP_SILENT,
        g_param_spec_boolean (
            "disable_csd", "Disable CSD",
            "Disable Client Side Decorations (CSD) for application",
            FALSE, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS
        )
    );
    
    g_object_class_install_property (
        object_class, PROP_SILENT,
        g_param_spec_boolean (
            "dark_theme", "Dark Theme",
            "Enable dark theme for application",
            FALSE, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS
        )
    );
}

static void
boilerplate_window_set_property (GObject      *object,
                                 guint         prop_id,
                                 const GValue *value,
                                 GParamSpec   *pspec)
{
    BoilerplateWindow *self = BOILERPLATE_WINDOW (object);
    BoilerplateWindowPrivate* priv = boilerplate_window_get_instance_private (self);

    switch (prop_id) {
        case PROP_DISABLE_CSD:
            priv->disable_csd = g_value_get_boolean (value);
            // g_print ("Silent argument was changed to %s\n", filter->silent ? "true" : "false");
            break;
        case PROP_DARK_THEME:
            priv->dark_theme = g_value_get_boolean (value);
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
            break;
    }
}

static void
boilerplate_window_get_property (GObject    *object,
                                 guint       prop_id,
                                 GValue     *value,
                                 GParamSpec *pspec)
{
    BoilerplateWindow *self = BOILERPLATE_WINDOW (object);
    BoilerplateWindowPrivate* priv = boilerplate_window_get_instance_private (self);

    switch (prop_id) {
        case PROP_DISABLE_CSD:
            g_value_set_boolean (value, priv->disable_csd);
            break;
        case PROP_DARK_THEME:
            g_value_set_boolean (value, priv->dark_theme);
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
            break;
    }
}
